local mod = ...

local mod = ...



-- Custom Component for Scaling -------------------------------------------------------------------------------------
local COMP_GIANT = {
	TypeName = "COMP_GIANT",
	ParentType = "COMPONENT",
	Properties = {
    }
}



-- Put listeners on new days

function COMP_GIANT:init()

    -- mod:log("COMP_GIANT ______________________________________________________________________________________")

    local compMainGameLoop = self:getLevel():find("COMP_MAIN_GAME_LOOP")

    event.register(self, compMainGameLoop.ON_NEW_DAY, function()

		-- Find all the giants and make them bigger
		self:getLevel():getComponentManager("COMP_VILLAGER"):getAllComponent():forEach(
			function(comp)
				-- mod:log("| CompVillager is initialized: "..tostring(comp:isInitialized()))
				-- mod:log("| Villager name: "..comp:getOwner().Name)
				-- mod:log("| Villager scale: "..tostring(comp.Scale))
				-- mod:log("| Villager job: "..tostring(comp:getAssetJob()))
				if (tostring(comp:getAssetJob()) == "Asset [\"JOB_SECURITY_GIANT.data - JOB\"]") then
                    comp:getOwner().Scale = {1.75, 1.5, 1.75}
                elseif comp:getOwner().Scale == nil then else
					comp:getOwner().Scale = {1, 1, 1}
                end
			end
		)

    end)

end


mod:registerClass(COMP_GIANT)


mod:registerPrefabComponent("models/Security1.fbx/Prefab/GiantPart/GiantPoint", { DataType = "COMP_BUILDING_PART" })
mod:registerPrefabComponent("models/Security1.fbx/Prefab/GiantPart/GiantPoint", { DataType = "COMP_GIANT" })



-- Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/Security1.fbx/Prefab/GiantPart/GiantPoint", "PREFAB_SECURITY_GIANTPOINT1")
mod:registerAssetId("models/Security1.fbx/Prefab/CharacterPart/GiantMale", "PREFAB_SECURITY_CHARACTER_GIANTMALE")



-- Building Part: Giant's Post -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_SECURITY_GIANT_POST",
	Name = "BUILDING_PART_SECURITY_GIANT_POST_NAME", 
	Description = "BUILDING_PART_SECURITY_GIANT_POST_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_SECURITY_GIANTPOINT1"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1, 1}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GIANT_POST",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 10 } },
        UpkeepCost = { { Resource = "GOLD", Quantity = 20 } },
        RessourcesNeeded = {
            -- { Resource = "PLANK", Quantity = 2 },
		}
	},
	IsVisibleWhenBuilt = false,
	IsMovableWhenBuilt = true
})



-- Building Function: Giant's Post -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_SECURITY_GIANT_POST",
    Name = "BUILDING_FUNCTION_SECURITY_GIANT_POST_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_SECURITY_GIANT", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
        { Resource = "RESOURCE_REPORT", Quantity = 2 },
    }
})



-- Job: Giant -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_SECURITY_GIANT",
	JobName = "JOB_SECURITY_GIANT_NAME",
	JobDescription = "JOB_SECURITY_GIANT_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 30.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        RightHandObject = {
			DataType = "HAND_OBJECT",
            Model = "PREFAB_TOOL_GUARD_SPEAR"
        },
        FemaleHatList = {
            "PREFAB_SECURITY_CHARACTER_GIANTMALE",
        }, 
        MaleHatList = {
            "PREFAB_SECURITY_CHARACTER_GIANTMALE",
        }, 
		WalkAnimation = "WALKING",
		IdleAnimation = "GUARD"
	}

})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_GIANT"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_GIANT"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_GIANT"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_GIANT"
    }
})


